<script lang="ts">
import Vue from 'vue';
import { NAV_CONTENT_TYPES } from '../../common/content-types';
import { convertToCaseSensitiveLocale } from '../../common/util';
import { getNavigationClient } from '~/plugins/contentful';
import { SearchEventMixin } from '~/mixins';
import {
  NAVIGATION_CTF_ID,
  NAVIGATION_VARIANT_CTF_ID,
} from '~/common/constants';
import LaunchDarkly from '../common/launch-darkly.vue';

export default Vue.extend({
  name: 'SlpNavigationHOC',
  components: {
    LaunchDarkly,
  },
  mixins: [SearchEventMixin],
  data() {
    return {
      searchVisible: false,
      navigation: {},
      navigationVariant: {},
    };
  },
  async fetch() {
    if (
      this.$nuxt.context.payload &&
      this.$nuxt.context.payload[this.$i18n.locale]['navigation']
    ) {
      // Production build
      const { navigation, navigationVariant } =
        this.$nuxt.context.payload[this.$i18n.locale];
      this.navigation = navigation;
      this.navigationVariant = navigationVariant;
    } else {
      if (process.env.NODE_ENV !== 'development') {
        // eslint-disable-next-line no-console
        console.log(
          `Info: Navigation payload not found, requesting navigation data -> Path: ${this.$route.fullPath}`,
        );
      }

      const { items } = await getNavigationClient().getEntries({
        content_type: NAV_CONTENT_TYPES.NAVIGATION,
        include: 3,
        'sys.id': NAVIGATION_CTF_ID,
        order: 'sys.id',
        locale: convertToCaseSensitiveLocale(this.$i18n.locale),
      });

      if (!items.length) {
        const error = `Navigation entry with id ${NAVIGATION_CTF_ID} not found`;
        // eslint-disable-next-line
        console.error(error);
        throw new Error(error);
      }

      const [navigation] = items;
      this.navigation = navigation;
      //separate nav entry for AB test/
      const navigationVariantEntry = await getNavigationClient().getEntries({
        content_type: NAV_CONTENT_TYPES.NAVIGATION,
        include: 3,
        'sys.id': NAVIGATION_VARIANT_CTF_ID,
        order: 'sys.id',
        locale: convertToCaseSensitiveLocale(this.$i18n.locale),
      });
      const [navigationVariant] = navigationVariantEntry.items;
      this.navigationVariant = navigationVariant;
    }
  },
  mounted() {
    document.addEventListener('searchClick', this.toggleDesktopSearch);

    window.addEventListener('load', () => {
      this.productMenuLabelListeners();
      this.solutionsMenuLabelListeners();
    });
  },
  methods: {
    closeDesktopSearch() {
      this.searchVisible = false;
    },
    toggleDesktopSearch() {
      this.searchVisible = !this.searchVisible;
      if (this.searchVisible) {
        this.sendFocusToSearch();
      }
    },
    openDesktopSearch() {
      this.searchVisible = true;
      this.sendFocusToSearch();
    },
    sendFocusToSearch() {
      const searchBarReference = this.$refs.searchBar as any;
      setTimeout(() => {
        searchBarReference?.$refs.searchInput.focus();
      }, 350);
    },
    solutionsMenuLabelListeners() {
      //solutions events
      const solutionsButton = document.querySelector(
        '.navigation-dropdown__button[name="Solutions"]',
      );
      if (solutionsButton) {
        solutionsButton.addEventListener('mouseenter', this.hoverLabel);
        const solutionsDropdown = solutionsButton.nextElementSibling;
        const solutionsChildrenLinks = solutionsDropdown.querySelectorAll(
          'a[data-nav-levelone="solutions"]',
        );

        solutionsChildrenLinks.forEach((element) => {
          element.addEventListener('click', this.clickedChildren);
        });
      }
    },
    productMenuLabelListeners() {
      //product events
      const productButton = document.querySelector(
        '.navigation-dropdown__button[name="Product"]',
      );
      if (productButton) {
        productButton.addEventListener('mouseenter', this.hoverLabel);
        const productDropdown = productButton.nextElementSibling;
        const productChildrenLinks = productDropdown.querySelectorAll(
          'a[data-nav-levelone="solutions"]',
        );

        productChildrenLinks.forEach((element) => {
          element.addEventListener('click', this.clickedChildren);
        });
      }
    },
    hoverLabel() {
      this.$refs.launchDarkly.fireCustomEvent(
        'navigation-solutions-menu-label-hover',
      );
    },
    clickedChildren() {
      this.$refs.launchDarkly.fireCustomEvent(
        'navigation-solutions-child-links-click',
      );
    },
  },
});
</script>

<template>
  <div class="nav-hoc">
    <client-only>
      <LaunchDarkly
        ref="launchDarkly"
        feature-flag="4303-test-replace-solutions-menu-label-with-product"
      >
        <template #control>
          <SlpNavigation
            free-trial-variant="primary"
            :contentful-navigation-data="navigation"
          />
        </template>
        <template #experiment>
          <SlpNavigation
            free-trial-variant="primary"
            :contentful-navigation-data="navigationVariant"
          />
        </template>
      </LaunchDarkly>
    </client-only>
  </div>
</template>

<style lang="scss">
.nav-hoc {
  background: $color-surface-50;
  min-height: 84px;
  position: sticky;
  left: 0;
  right: 0;
  top: 0;
  z-index: 1025;

  @media (min-width: 576px) and (max-width: 1024px) {
    min-height: 80px;
  }

  @media (max-width: 575px) {
    min-height: 116px;
  }

  .navigation-dropdown__popover {
    a {
      text-decoration: none !important;
    }
  }
}
</style>
